import { world, system } from '@minecraft/server'

/*world.beforeEvents.itemUse.subscribe(ui => {
    const item = ui.itemStack
    const player = ui.source
    if (item.typeId == 'deep_end:dislocator') {
        system.run(() => {
            player.runCommandAsync('say hi')
            player.runCommandAsync('execute as @s run function dislocate')
        }
        )
    }
})

world.afterEvents.itemUse.subscribe(ui => {
    const item = ui.itemStack
    const player = ui.source
    if (item.typeId == 'deep_end:dislocator') {
        system.run(() => {
            player.applyKnockback((Math.random() * (1 + .5)) + -.5, (Math.random() * (1 + .5)) + -.5, (Math.random() * (1 + .5)) + -.5, (Math.random() * (.25 + .5)) + .25);
        }
        )
    }
})*/

world.beforeEvents.itemUse.subscribe(ui => {
    const item = ui.itemStack
    const player = ui.source
    //const itemCooldown = item.getComponent('cooldown').cooldownTicks
    const itemCooldown = player.getItemCooldown('dislocator')
    if (item.typeId == 'deep_end:dislocator' && itemCooldown == 0) {
        system.run(() => {
            player.runCommandAsync('scriptevent deep_end:calculate_user_dislocate')
            //player.runCommandAsync(`say ${itemCooldown}`)

        }
        )
    }
})

system.afterEvents.scriptEventReceive.subscribe((event) => {
    const { id, message, sourceEntity, sourceType } = event;

    console.log(id); // wiki:test
    console.log(message); // Hello World
    console.log(sourceEntity); // Player object
    console.log(sourceType); // Entity
    if (event.id == 'deep_end:dislocate_used') {
        //sourceEntity.applyDamage((`5 + ${preFall}`), fall)

    };
    if (event.id == 'deep_end:dislocate') {
        sourceEntity.applyKnockback((Math.random() * (4 - -4)) + -4, (Math.random() * (4 - -4)) + -4, (Math.random() * (4 - -4)) + -4, (0.15 + Math.random() * (.25 - .5)) + .5);
        sourceEntity.runCommandAsync(`particle deep_end:dislocate_particle ~ ~ ~`)
        //(Math.random() * (1 + .5)) + -.5          
    };
    if (event.id == 'deep_end:calculate_user_dislocate') {
        const preFall = Math.floor(5 + (sourceEntity.fallDistance / 4))
        //sourceEntity.applyDamage((`5 + ${preFall}`), fall)
        sourceEntity.runCommandAsync(`damage @s[tag=!ender_colleague] ${preFall} fall`)
        sourceEntity.runCommandAsync(`particle deep_end:dislocator_use ~ ~ ~`)

        //sourceEntity.runCommandAsync(`say ${preFall}`)

        sourceEntity.runCommandAsync(`function dislocate`)

    };
});